--AH:ScriptId=b1d36afc-9507-4686-acfa-3887aa3ffe1e;167

exec sp_MsForEachTable 'ALTER TABLE ? NOCHECK CONSTRAINT ALL'

-- Applications
ALTER TABLE Applications DROP CONSTRAINT [UQ__Applications__Application_Name]
ALTER TABLE Applications ALTER  COLUMN Application_Name VARCHAR( 50 ) COLLATE SQL_Latin1_General_CP1_CI_AS NOT NULL
ALTER TABLE Applications ADD CONSTRAINT [UQ__Applications__Application_Name] UNIQUE ([Application_Name])

-- BuildApprovals
ALTER TABLE BuildApprovals DROP CONSTRAINT [UQ__BuildApprovals]
ALTER TABLE BuildApprovals ALTER  COLUMN User_Name VARCHAR( 255 ) COLLATE SQL_Latin1_General_CP1_CI_AS NOT NULL
ALTER TABLE BuildApprovals ALTER  COLUMN Group_Name VARCHAR( 255 ) COLLATE SQL_Latin1_General_CP1_CI_AS NULL
ALTER TABLE BuildApprovals ADD CONSTRAINT [UQ__BuildApprovals] UNIQUE([Application_Id], [Release_Number], [Build_Number], [Workflow_Id], [Environment_Id], [User_Name], [Group_Name])

-- BuildArtifacts
ALTER TABLE BuildArtifacts DROP CONSTRAINT [PK__BuildArtifacts]
ALTER TABLE BuildArtifacts ALTER  COLUMN Artifact_Name VARCHAR( 40 ) COLLATE SQL_Latin1_General_CP1_CI_AS NOT NULL
ALTER TABLE BuildArtifacts ADD CONSTRAINT [PK__BuildArtifacts] PRIMARY KEY ([Application_Id], [Release_Number], [Build_Number], [Artifact_Name])

--BuildPromotions
ALTER TABLE BuildPromotions ALTER  COLUMN PromotedBy_Name VARCHAR( 255 ) COLLATE SQL_Latin1_General_CP1_CI_AS NOT NULL

-- Environments
ALTER TABLE Environments DROP CONSTRAINT [UQ__Environments__Environment_Name]
ALTER TABLE Environments ALTER  COLUMN Environment_Name VARCHAR( 50 ) COLLATE SQL_Latin1_General_CP1_CI_AS NOT NULL
ALTER TABLE Environments ADD CONSTRAINT [UQ__Environments__Environment_Name] UNIQUE([Environment_Name])

-- PromotionApprovalRequirements
ALTER TABLE PromotionApprovalRequirements ALTER  COLUMN User_Name VARCHAR( 255 ) COLLATE SQL_Latin1_General_CP1_CI_AS NOT NULL

--Providers
ALTER TABLE Providers ALTER  COLUMN Provider_Description VARCHAR( MAX ) COLLATE SQL_Latin1_General_CP1_CI_AS NOT NULL

--Releases
ALTER TABLE Releases DROP CONSTRAINT CK__Releases__ReleasesStatus_Name_Domain
ALTER TABLE Releases ALTER  COLUMN ReleaseStatus_Name VARCHAR( 9 ) COLLATE SQL_Latin1_General_CP1_CI_AS NOT NULL
ALTER TABLE Releases ALTER  COLUMN Release_Name VARCHAR( 50 ) COLLATE SQL_Latin1_General_CP1_CI_AS NULL
ALTER TABLE Releases ADD CONSTRAINT [CK__Releases__ReleasesStatus_Name_Domain] CHECK ([ReleaseStatus_Name] IN ('Active', 'Cancelled', 'Deployed'))

--Servers
ALTER TABLE Servers DROP CONSTRAINT UQ__Servers__Server_Name
ALTER TABLE Servers ALTER  COLUMN Server_Name VARCHAR( 50 ) COLLATE SQL_Latin1_General_CP1_CI_AS NOT NULL
ALTER TABLE Servers ALTER  COLUMN Agent_Url VARCHAR( 255 ) COLLATE SQL_Latin1_General_CP1_CI_AS NULL
ALTER TABLE Servers ADD CONSTRAINT [UQ__Servers__Server_Name] UNIQUE([Server_Name])

--Solutions
ALTER TABLE Solutions DROP CONSTRAINT UQ__Solutions__ApplicationSolution_Name
ALTER TABLE Solutions ALTER  COLUMN Solution_Name VARCHAR( 50 ) COLLATE SQL_Latin1_General_CP1_CI_AS NOT NULL
ALTER TABLE Solutions ADD CONSTRAINT [UQ__Solutions__ApplicationSolution_Name] UNIQUE ([Application_Id], [Solution_Name])

--Users
ALTER TABLE Users ALTER  COLUMN Display_Name VARCHAR( 100 ) COLLATE SQL_Latin1_General_CP1_CI_AS NOT NULL
ALTER TABLE Users ALTER  COLUMN Email_Address VARCHAR( 250 ) COLLATE SQL_Latin1_General_CP1_CI_AS NULL

--Workflows
ALTER TABLE Workflows ALTER  COLUMN Workflow_Name VARCHAR( 20 ) COLLATE SQL_Latin1_General_CP1_CI_AS NOT NULL

exec sp_MsForEachTable 'ALTER TABLE ? CHECK CONSTRAINT ALL'

