--AH:ScriptId=1f0c1725-2b29-4356-9edd-284cd195924e;2759
CREATE TABLE [BuildPromotionRequirements]
(
	[Requirement_Id] INT IDENTITY(1,1) NOT NULL,
	[Workflow_Id] INT NULL,
	[Environment_Id] INT NOT NULL,
	[Principal_Name] USERNAME NULL,
	[RequiredInGroup_Count] INT NULL,
	[Requirement_Description] NVARCHAR(1000) NOT NULL,
	[Requirement_Configuration] XML NULL,
	[CreatedBy_User_Name] USERNAME NOT NULL,
	[CreatedOn_Date] DATETIME NOT NULL,
	[ModifiedBy_User_Name] USERNAME NOT NULL,
	[ModifiedOn_Date] DATETIME NOT NULL,

	CONSTRAINT [PK__BuildPromotionRequirements]
		PRIMARY KEY ([Requirement_Id]),

	CONSTRAINT [FK__BuildPromotionRequirements__Workflows]
		FOREIGN KEY ([Workflow_Id])
		REFERENCES [Workflows] ([Workflow_Id]),

	CONSTRAINT [FK__BuildPromotionRequirements__Environments]
		FOREIGN KEY ([Environment_Id])
		REFERENCES [Environments] ([Environment_Id]),

	CONSTRAINT [CK__BuildPromotionRequirements__RequiredInGroup_Count]
		CHECK ([RequiredInGroup_Count] IS NULL OR [RequiredInGroup_Count] > 0),

	CONSTRAINT [CK__BuildPromotionRequirements__RequirementType]
		CHECK (([Principal_Name] IS NOT NULL AND [Requirement_Configuration] IS NULL)
		   OR  ([Principal_Name] IS NULL AND [RequiredInGroup_Count] IS NULL AND [Requirement_Configuration] IS NOT NULL))
)