--AH:ScriptId=d6594d02-9b1a-42ec-8eae-219f5d9bf11b;2808
DECLARE @Mapping TABLE
(
	[Application_Id] INT NOT NULL,
	[Release_Number] RELEASENUMBER NOT NULL,
	[ConfigurationFile_Id] INT NOT NULL,
	[Version_Number] INT NOT NULL
)

INSERT INTO @Mapping
SELECT *
  FROM [ReleaseConfigurationFiles]

DELETE [ReleaseConfigurationFiles]

INSERT INTO [ReleaseConfigurationFiles]
SELECT [Application_Id],
       [Release_Number],
	   [ConfigurationFile_Id],
	   [Version_Number] = COALESCE([Max_Version_Number], [Latest_Version_Number])
  FROM (SELECT R.[Application_Id],
               R.[Release_Number],
			   R.[ReleaseStatus_Name],
	           CF.[ConfigurationFile_Id],
               [Max_Version_Number] = (SELECT TOP 1 [Version_Number]
	                                     FROM @Mapping M
					                          INNER JOIN [Releases] M_R
						                              ON M_R.[Application_Id] = M.[Application_Id]
								                     AND M_R.[Release_Number] = M.[Release_Number]
					                    WHERE M.[Application_Id] = R.[Application_Id]
				           	              AND M_R.[Release_Sequence] <= R.[Release_Sequence]
								          AND M.[ConfigurationFile_Id] = CF.[ConfigurationFile_Id]
					                    ORDER BY [Version_Number] DESC),
	           [Latest_Version_Number] = (SELECT TOP 1 CFV.[Version_Number]
	                                        FROM [ConfigurationFileVersions] CFV
								           WHERE CFV.[ConfigurationFile_Id] = CF.[ConfigurationFile_Id]
								           ORDER BY CFV.[Version_Number] DESC)
          FROM [ConfigurationFiles] CF
               INNER JOIN [Deployables] D
	                   ON D.[Deployable_Id] = CF.[Deployable_Id]
	           INNER JOIN [Releases] R
	                   ON R.[Application_Id] = D.[Application_Id]) CFG
 WHERE ([Max_Version_Number] IS NOT NULL OR [Latest_Version_Number] IS NOT NULL)
   AND ([ReleaseStatus_Name] = 'Deployed' OR [Max_Version_Number] <> [Latest_Version_Number])