EXEC [dbo].[__BuildMaster_AddStoredProcInfo]
    /* StoredProc_Name         */ 'Applications_GetApplications',
    /* Internal_Indicator      */ 'N',
    /* ReturnType_Name         */ 'DataTable',
    /* DataTableNames_Csv      */ 'Applications_Extended',
    /* OutputPropertyNames_Csv */ NULL,
    /* Description_Text        */ 'Gets the specified number of applications in the system, or all if null is passed in'
GO


IF OBJECT_ID('[Applications_GetApplications]') IS NOT NULL DROP PROCEDURE [Applications_GetApplications]
GO

SET QUOTED_IDENTIFIER ON
GO

CREATE PROCEDURE [Applications_GetApplications]
(
    @Application_Count INT,
    @IncludeInactive_Indicator YNINDICATOR = NULL
)
AS
BEGIN

	SET NOCOUNT ON
	
	IF @Application_Count IS NOT NULL
        SET ROWCOUNT @Application_Count

	SELECT * FROM [Applications_Extended]
    WHERE @IncludeInactive_Indicator = 'Y' OR [Active_Indicator] = 'Y'
	ORDER BY [ApplicationGroup_Name], [Application_Name]

END
GO

GRANT EXECUTE ON [Applications_GetApplications] TO [BuildMasterUser_Role]
