﻿IF OBJECT_ID('[RepositoryMonitors_DeleteRepositoryMonitor]') IS NOT NULL DROP PROCEDURE [RepositoryMonitors_DeleteRepositoryMonitor]
GO

SET QUOTED_IDENTIFIER ON
GO

EXEC [dbo].[__BuildMaster_AddStoredProcInfo]
    /* StoredProc_Name         */ 'RepositoryMonitors_DeleteRepositoryMonitor',
    /* Internal_Indicator      */ 'N',
    /* ReturnType_Name         */ 'void',
    /* DataTableNames_Csv      */ NULL,
    /* OutputPropertyNames_Csv */ NULL,
    /* Description_Text        */ 'Deletes a repository monitor.'
GO

CREATE PROCEDURE [RepositoryMonitors_DeleteRepositoryMonitor]
(
	@RepositoryMonitor_Id INT
)
AS
BEGIN

SET NOCOUNT ON

BEGIN TRY
	BEGIN TRANSACTION

	DELETE [RepositoryMonitors]
	 WHERE [RepositoryMonitor_Id] = @RepositoryMonitor_Id

	COMMIT
END TRY BEGIN CATCH
	IF XACT_STATE()<>0 ROLLBACK
	EXEC [HandleError]
END CATCH

END
GO

GRANT EXECUTE ON [RepositoryMonitors_DeleteRepositoryMonitor] TO [BuildMasterUser_Role]
